// Tempo do auto refresh (em milisegundos)
var time_refresh = 300000;
// tempo do auto save (em milisegundos)
// 20000 = 20 segundos
var autosave_time = 20000;

function init(){
	if (!is_ie)
		Element('tableDivAppbox').width = '100%';
	
	var save_contacts = function(data){
		contacts = data;
	}
	var save_preferences = function(data){
		preferences = data;
		if(preferences.hide_folders == "1")
			Element('divAppboxHeader').innerHTML =  title_app_menu;

		if (preferences.delete_trash_messages_after_n_days != 0)
			cExecute ("$this.imap_functions.automatic_trash_cleanness&before_date="+preferences.delete_trash_messages_after_n_days+"&cyrus_delimiter="+cyrus_delimiter, handler_automatic_trash_cleanness);

		if(preferences.outoffice == "1")
			write_msg(get_lang("Attention, you are in out of office mode."), true);
		ConstructMenuTools();
		cExecute ("$this.imap_functions.get_folders_list", update_menu);
	}
	var handler_automatic_trash_cleanness = function(data){
		if (data != false){
			write_msg(data.length +' '+ Element('txt_clear_trash').value);
		}
	}
	
	// Verso
	Element('divAppboxHeader').innerHTML = title_app;
	
	// Get cyrus delimiter
	cyrus_delimiter = Element('cyrus_delimiter').value;
	
	cExecute ("$this.db_functions.get_dropdown_contacts", save_contacts);
	cExecute ("$this.functions.get_preferences", save_preferences);
	setTimeout('auto_refresh()', time_refresh);
}
function disable_field(field,condition) {
	var comando = "if ("+condition+") { document.getElementById('"+field.id+"').disabled=true;} else { document.getElementById('"+field.id+"').disabled=false; }";
	eval(comando);
}
/*
	funo que remove todos os anexos...
*/
function remove_all_attachments(folder,msg_num) {

	var call_back = function(data) {
					if(!data.status) { //Em caso de erros, o status vem como false e o texto do erro vem em msg.
						alert(data.msg);
					}
					else {
						mail_msg = Element("tbody_box");
						msg_to_delete = Element(data.msg_num);
						if (msg_to_delete) {
							if ( (msg_to_delete.style.backgroundColor != '') && (preferences.use_shortcuts == '1') )
								select_msg('null', 'down');
							mail_msg.removeChild(msg_to_delete);												
						}//Remove o email com anexos da lista de emails.
						write_msg(get_lang("Attachments removed"));//indica que os anexos foram removidos
						refresh(); //d um refresh na lista de emails, para que aparea o novo email sem anexos
						delete_border(data.msg_num+'_r','false');//fecha a tela do email j removido.
					}
				};
	if (confirm(get_lang("delete all attachments confirmation")))
		cExecute ("$this.imap_functions.remove_attachments&folder="+folder+"&msg_num="+msg_num, call_back); //chamada em ajax para a funo de remover anexos.
}
function watch_changes_in_msg(border_id)
{
	if (document.getElementById('border_id_'+border_id))
	{	
		function keypress_handler ()
		{
			away=false;
			var save_link = Element("save_message_options_"+border_id);
			save_link.onclick = function onclick(event) { openTab.toPreserve[border_id] = true; save_msg(border_id); } ;
			save_link.style.color = '#0000ff';
		};
		
		var obj = document.getElementById('body_'+border_id).contentWindow.document;
		if ( obj.addEventListener )
				obj.addEventListener('keypress', keypress_handler, false);
		else if ( obj.attachEvent )
			obj.attachEvent('onkeypress', keypress_handler);
			
		var subject_obj = document.getElementById('subject_'+border_id);
		if ( subject_obj.addEventListener )
				subject_obj.addEventListener('keypress', keypress_handler, false);
		else if ( subject_obj.attachEvent )
			subject_obj.attachEvent('onkeypress', keypress_handler);
			
		var to_obj = document.getElementById('to_'+border_id);
		if ( to_obj.addEventListener )
				to_obj.addEventListener('keypress', keypress_handler, false);
		else if ( to_obj.attachEvent )
			to_obj.attachEvent('onkeypress', keypress_handler);
		
	}
}



function show_msg(msg_info){	
	if(!verify_session(msg_info))
		return;
	
	if (msg_info.status_get_msg_info == 'false')
	{
		write_msg(get_lang("Problems reading your message")+ ".");
		return;
	}
	
	var handler_sendNotification = function(data){
		if (data)
			write_msg(get_lang("A read confirmation was sent."));
		else
			write_msg(get_lang("Error in SMTP sending read confirmation."));
	}
	
	if (msg_info.status == 'false'){
		eval(msg_info.command_to_exec);
	}
	else{
		if (preferences.use_shortcuts == '1')
			select_msg(msg_info.msg_number, 'null');
		// Call function to draw message
		var id_msg_read = msg_info.msg_number +"_r";
		// If needed, delete old border
		if (openTab.type[currentTab] == 2 || openTab.type[currentTab] == 3)
			delete_border(currentTab,'false');

		
		if(Element("border_id_" + id_msg_read)) 
			alternate_border(id_msg_read);		
		else {
			var border_id = create_border(msg_info.subject, id_msg_read);
			if(border_id)
				draw_message(msg_info,border_id);
			else
				return;
		}

		var domains = "";
		if ((msg_info.DispositionNotificationTo) && (!msg_is_read(msg_info.msg_number) || (msg_info.Recent == 'N')))
		{			
			if (preferences.notification_domains != undefined && preferences.notification_domains != "")
				domains = preferences.notification_domains.split(',');
			else
			{				
				var confNotification = true;
			 }
			for (var i = 0; i < domains.length; i++)
				if (msg_info.DispositionNotificationTo.match(domains[i]+">"))
				{
					var confNotification = true;
					break;
				}
				if (confNotification == undefined)
					var confNotification = confirm(get_lang("The sender:\n%1\nwaits your notification of reading. Do you want to confirm this?",msg_info.DispositionNotificationTo), "");

			if (confNotification)
				cExecute ("$this.imap_functions.send_notification&notificationto="+msg_info.DispositionNotificationTo+"&subject="+url_encode(msg_info.subject), handler_sendNotification);
		}
		//Change msg class to read.
		if (!msg_is_read(msg_info.msg_number))
		{
			set_msg_as_read(msg_info['msg_number'], true);
			if (msg_info.cacheHit)
				set_message_flag(msg_info.msg_number, "seen"); // avoid caducous (lazy) data
		}

	}
}

function auto_refresh(){
	refresh(preferences.alert_new_msg);
	setTimeout('auto_refresh()', time_refresh);
}

function refresh(alert_new_msg){
	var handler_refresh = function(data){
		if(!verify_session(data))
			return;
		if (data.length > 0){
			var msg_info = document.getElementById('msg_info')
			if (msg_info != null)
				main.removeChild(msg_info);

			table_element = Element("table_box");
			var box = Element("tbody_box");
			table_element.appendChild(box);
			for (var i=0; i<data.length; i++){
				var new_msg = this.make_tr_message(data[i], current_folder);
				_dragArea.makeDragged(new_msg, data[i].msg_number, data[i].subject, true);
				eval(data[i].command);
			}
			
			for (var i=0; i<data.msgs_to_delete.length; i++){
				var remove_msg = document.getElementById(data.msgs_to_delete[i]);
				if (remove_msg)
					remove_msg.parentNode.removeChild(remove_msg);
			}
			if(parseInt(alert_new_msg) && data.new_msgs > 0)
				alert(get_lang("You have %1 new", data['new_msgs'])+" "+(data['new_msgs'] > 1 ? get_lang("messages") : get_lang("message")) +"!");
			if(data.new_msgs > 0){
			Element('tot_m').innerHTML = parseInt(Element('tot_m').innerHTML) + parseInt(data.new_msgs); //refresh tab title
			update_quota(get_current_folder());
			}
			 //if(data.new_msgs > 0 || data.msgs_to_delete.length > 0)
			//	purgeCache();
		}
		purgeCache();
		update_menu();
	}

	msg_range_end = (current_page*preferences.max_email_per_page);
	msg_range_begin = (msg_range_end-(preferences.max_email_per_page)+1);
	
	
	//Get element tBody.
	main = Element("tbody_box");
	if(!main)
		return;	

	// Get all TR (messages) in tBody.
	main_list = main.childNodes;
	var tmp = '';
	var string_msgs_in_main = '';

	var len = main_list.length; 
	for (var j=0; j < len; j++)
		tmp += main_list[j].id + ',';
		
	string_msgs_in_main = tmp.substring(0,(tmp.length-1));
	cExecute ("$this.imap_functions.refresh&folder="+current_folder+"&msgs_existent="+string_msgs_in_main+"&msg_range_begin="+msg_range_begin+"&msg_range_end="+msg_range_end+"&sort_box_type="+sort_box_type+"&search_box_type="+search_box_type+"&sort_box_reverse="+sort_box_reverse, handler_refresh);
}

function delete_msgs2(folder, msgs_number, border_ID, show_success_msg) {
	if (folder == 'null')
		folder = get_current_folder();

	if ((parseInt(preferences.save_deleted_msg)) && (folder!='INBOX'+cyrus_delimiter+trashfolder)){
		move_msgs2(folder, msgs_number, border_ID, 'INBOX'+cyrus_delimiter+trashfolder,trashfolder,show_success_msg );
		return;
	}
	
	var handler_delete_msgs = function(data){
		Element('chk_box_select_all_messages').checked = false;
		mail_msg = Element("tbody_box");
		
		if ( preferences.use_shortcuts == '1') {
			var all_messages = Element('tbody_box').childNodes;

			//Last msg is selected
			if ( exist_className(all_messages[all_messages.length-1], 'selected_shortcut_msg') ) {
				select_msg('null', 'up', true);
			}
			else {
				if (!select_msg('null', 'down', true)) {
					select_msg('null', 'up', true);
				}
			}
		}
		
		var msg_to_delete;
		for (var i=0; i<data.msgs_number.length; i++){
			msg_to_delete = Element(data.msgs_number[i]);
			if (msg_to_delete){
				mail_msg.removeChild(msg_to_delete);
			}
		}
		if (show_success_msg) {
			if (data.msgs_number.length == 1) 
				write_msg(get_lang("The message was deleted."));
			else 
				write_msg(get_lang("The messages were deleted."));
		}

		if (data.border_ID != 'null'){
			if (parseInt(preferences.delete_and_show_previous_message))
				show_msg(data.previous_msg);
			else
				delete_border(data.border_ID,'false');
		}
		Element('tot_m').innerHTML = parseInt(Element('tot_m').innerHTML) - data.msgs_number.length;
		refresh();
	}

	if (msgs_number == 'selected')
		msgs_number = get_selected_messages();
	if (msgs_number.length > 0 || parseInt(msgs_number) > 0)
		cExecute ("$this.imap_functions.delete_msgs&folder="+folder+"&msgs_number="+msgs_number+"&border_ID="+border_ID+"&sort_box_type="+sort_box_type+"&search_box_type="+search_box_type+"&sort_box_reverse="+sort_box_reverse+"&reuse_border="+border_ID+"&get_previous_msg="+preferences.delete_and_show_previous_message, handler_delete_msgs);
	else
		write_msg(get_lang('No selected message.'));		
}
function delete_msgs(folder, msgs_number, border_ID)
{ 
	delete_msgs2(folder, msgs_number, border_ID, true);
}


function move_search_msgs(border_id, new_folder, new_folder_name){
	var selected_messages = '';
	var temp_msg;
	var main_list = Element("tbody_resultsearch_"+border_id.substr(18)).childNodes;	
	for (j = 0; j < main_list.length; j++)	{
		var check_box = main_list[j].firstChild.firstChild; 
		if(check_box && check_box.checked) {
			if (proxy_mensagens.is_local_folder(main_list[j].name)) {
				alert(get_lang("You cant manipulate local messages on search"));
				return;
			}
			selected_messages += main_list[j].id + ',';
		}
	}
	selected_messages = selected_messages.substring(0,(selected_messages.length-1));
	var handler_move_search_msgs = function(data){
		if(!data || !data.msgs_number)
			return;
		else if(data.deleted) {			
			if (data.msgs_number.length == 1)
				write_msg(get_lang("The message was deleted."));
			else
				write_msg(get_lang("The messages were deleted."));			
		}
		else{
			if (data.msgs_number.length == 1)
				write_msg(get_lang("The message was moved to folder ") + lang_folder(data.new_folder_name));
			else
				write_msg(get_lang("The messages were moved to folder ") + lang_folder(data.new_folder_name));
		}

		selected_messages = selected_messages.split(",");
		for (i = 0; i < selected_messages.length; i++){
			var tr = Element(selected_messages[i]);
			tr.parentNode.removeChild(tr);
		}			
	}	

	if (selected_messages){
		var selected_param = "";
		if (selected_messages.indexOf(',') != -1)
		{
			selected_msg_array = selected_messages.split(",");
			for (i = 0; i < selected_msg_array.length; i++){
				var tr = Element(selected_msg_array[i]);
			        selected_param += ','+tr.name+';'+tr.id;
			}
		}
		else
		{
			var tr=Element(selected_messages);
			selected_param=tr.name+';'+tr.id;
		}
		var params = "";
		if (!new_folder && parseInt(preferences.save_deleted_msg)){ 
			new_folder = 'INBOX'+cyrus_delimiter+trashfolder;
			new_folder_name = trashfolder;
			params = "&delete=true";
		}			
		
		params += "&selected_messages="+url_encode(selected_param);
		if(new_folder) {
			params += "&new_folder="+url_encode(new_folder);
			params += "&new_folder_name="+url_encode(new_folder_name);
		}
		cExecute ("$this.imap_functions.move_search_messages", handler_move_search_msgs, params);
	}
	else
		write_msg(get_lang('No selected message.'));		
}

function move_msgs2(folder, msgs_number, border_ID, new_folder, new_folder_name,show_success_msg){

	if (! folder || folder == 'null')
		folder = Element("input_folder_"+msgs_number+"_r") ? Element("input_folder_"+msgs_number+"_r").value : get_current_folder();
	
	var handler_move_msgs = function(data){
		if(typeof(data) == 'string')
			if (data.match(/^(.*)TRYCREATE(.*)$/)){
				connector.loadScript('TreeS');
				var move_to_folder = data.match(/^(.*)Spam(.*)$/) ? "Spam" : trashfolder;
				alert(get_lang('There is not %1 folder, Expresso is creating it for you... Please, repeat your request later.', move_to_folder));
				connector.loadScript('TreeShow');
				ttree.FOLDER = 'root';
				ttreeBox.new_past(move_to_folder);
				return false;
			}else{
				alert(data);
				return false;
			}
		//Este bloco verifica as permissoes ACL sobre pastas compartilhadas
		if(data.status == false){
			alert(get_lang("You don't have permission for this operation in this shared folder!"));
			return false;
		}
		
		Element('chk_box_select_all_messages').checked = false;
		
		mail_msg = ( Element("divScrollMain_"+numBox) ) ? Element("divScrollMain_"+numBox).firstChild.firstChild : Element("divScrollMain_0").firstChild.firstChild;
		if (! mail_msg)
				mail_msg = Element("tbody_box");
		data.msgs_number = data.msgs_number.split(",");

		var msg_to_delete;
		if( typeof(msgs_number) == 'string' )
			all_search_msg = msgs_number.split(',');
		else
			all_search_msg = msgs_number;

		for (var i=0; i <= all_search_msg.length; i++)
		{
			msg_to_delete = Element(folder+';'+all_search_msg[i]); 
			if (msg_to_delete)
				msg_to_delete.parentNode.removeChild(msg_to_delete);
		}

		if ( preferences.use_shortcuts == '1') {
			var all_messages = Element('tbody_box').childNodes;

			//Last msg is selected
			if ( exist_className(all_messages[all_messages.length-1], 'selected_shortcut_msg') ) {
				select_msg('null', 'up', true);
			}
			else {
				if (!select_msg('null', 'down', true)) {
					select_msg('null', 'up', true);
				}
			}
		}

		for (var i=0; i<data.msgs_number.length; i++)
		{
			msg_to_delete = Element(data.msgs_number[i]);
			if (msg_to_delete)
				mail_msg.removeChild(msg_to_delete);
		}
		
		if (show_success_msg) {
			if (data.msgs_number.length == 1)
				write_msg(get_lang("The message was moved to folder ") + lang_folder(data.new_folder_name));
			else 
				write_msg(get_lang("The messages were moved to folder ") + lang_folder(data.new_folder_name));
		}

		if (data.msgs_number.length == 1)
			write_msg(get_lang("The message was moved to folder ") + lang_folder(data.new_folder_name));
		else
			write_msg(get_lang("The messages were moved to folder ") + lang_folder(data.new_folder_name));
		if (data.border_ID.indexOf('r') != -1){
			if (parseInt(preferences.delete_and_show_previous_message) && folder == get_current_folder()){
				delete_border(data.border_ID,'false');
				show_msg(data.previous_msg);
				}
			else
				delete_border(data.border_ID,'false');
		}
		if(folder == get_current_folder())
			Element('tot_m').innerHTML = parseInt(Element('tot_m').innerHTML) - data.msgs_number.length;			
		refresh();
	}

	if (folder == new_folder){
		write_msg(get_lang('The origin folder and the destination folder are the same.'));
		return;
	}

	if (msgs_number == 'selected')
		msgs_number = get_selected_messages();

	if (parseInt(msgs_number) > 0 || msgs_number.length > 0)
		cExecute ("$this.imap_functions.move_messages&folder="+folder+"&msgs_number="+msgs_number+"&border_ID="+border_ID+"&sort_box_type="+sort_box_type+"&search_box_type="+search_box_type+"&sort_box_reverse="+sort_box_reverse+"&reuse_border="+border_ID+"&new_folder="+new_folder+"&new_folder_name="+new_folder_name+"&get_previous_msg="+preferences.delete_and_show_previous_message, handler_move_msgs);
	else
		write_msg(get_lang('No selected message.'));		
		
}

function move_msgs(folder, msgs_number, border_ID, new_folder, new_folder_name) {
	move_msgs2(folder, msgs_number, border_ID, new_folder, new_folder_name,true);
}

function archive_msgs(folder,folder_dest,id_msgs) {
	if(proxy_mensagens.is_local_folder(folder)) {
		write_msg(get_lang("You cant archive local mails"));
		return;
	}
	var has_local_messages_before = expresso_local_messages.has_local_mails(); //vejo se j tinha mensagens locais
	var handler_arquivar_mensagens = function(data) {
		var sucess = true;
		var temp;
		var msgs_to_remove = new Array();
		var update_tree;


		for (var i = 0; i < data.length; i++) {
			msg_info = connector.unserialize(data[i]);
			temp = expresso_local_messages.insert_mail(msg_info, msg_info['header'],msg_info['array_attach'],folder_dest );
			Element("check_box_message_" + msg_info.msg_number).checked = false;
			if(!temp)
				sucess = false;
			else
				msgs_to_remove.push(msg_info.msg_number);//As mensagens arquivadas devem ser removidas, caso o usu�rio tenha isso configurado.
		}
		
		if (preferences.keep_archived_messages == 0) { //Remove as mensagens
				delete_msgs2(folder,msgs_to_remove,'null',false);
		}
		update_tree=(!has_local_messages_before) && expresso_local_messages.has_local_mails();
		
		Element('chk_box_select_all_messages').checked = false;
		if(update_tree)
			ttreeBox.update_folder();
		else
			update_menu();
		if(sucess) 
			write_msg(get_lang("selected messages have been archived"));
		else
			write_msg(get_lang("at least, one of selected mails is already archived, expresso tried to archive the others, check them later"));

	}	
	if(!id_msgs)
		id_msgs = get_selected_messages();
	if (parseInt(id_msgs) > 0 || id_msgs.length > 0) 
		cExecute("$this.imap_functions.get_info_msgs&folder=" + folder + "&msgs_number=" + id_msgs , handler_arquivar_mensagens);
	else 
		write_msg(get_lang('No selected message.'));
	
}

function get_selected_messages(){
	main = document.getElementById("divScrollMain_"+numBox).firstChild.firstChild;
	if (! main)
		main = Element("tbody_box");

	// Get all TR (messages) in tBody.
	main_list = main.childNodes;

	var selected_messages = '';
	var selected_messages_by_shortcuts = '';
	var j = 0;
	for (j; j<(main_list.length); j++)
	{
	check_box = Element("check_box_message_"+main_list[j].id);
	if ( (check_box) && (check_box.checked) )
		selected_messages += main_list[j].id + ',';
		
		if (preferences.use_shortcuts == '1')
		{
			if ( exist_className(Element(main_list[j].id), 'selected_shortcut_msg') )
			{
				selected_messages_by_shortcuts += main_list[j].id + ',';
			}
		}
	}
	selected_messages = selected_messages.substring(0,(selected_messages.length-1));
	
	if (preferences.use_shortcuts == '1')
	{
		selected_messages_by_shortcuts = selected_messages_by_shortcuts.substring(0,(selected_messages_by_shortcuts.length-1));
		
		var array_selected_messages_by_shortcuts = selected_messages_by_shortcuts.split(",");
		var array_selected_messages = selected_messages.split(",");
		
		if ((array_selected_messages.length <= 1) && (array_selected_messages_by_shortcuts.length > 1))
		{
			return selected_messages_by_shortcuts;
		}
	}
	
	if (selected_messages == '')
		return false;
	else
		return selected_messages;
}

function replaceAll(string, token, newtoken) {
	while (string.indexOf(token) != -1) {
 		string = string.replace(token, newtoken);
	}
	return string;
}

function new_message_to(email) {
	var new_border_ID = new_message('new','null');
	document.getElementById("to_" + new_border_ID).value=email;
}

function new_message(type, border_ID){
	var new_border_ID = draw_new_message(parseInt(border_ID));
	if (new_border_ID == false)
		return false;	
        openTab.type[new_border_ID] = tabTypes[type];

	// Salva a pasta da mensagem respondida ou encaminhada:
	var folder_message = Element("input_folder_"+border_ID);
	if(folder_message) {
		var input_current_folder = document.createElement('input');	
		input_current_folder.id = "new_input_folder_"+border_ID;
		input_current_folder.name = "input_folder";
		input_current_folder.type = "hidden";
		input_current_folder.value = folder_message.value;
		Element("content_id_" + new_border_ID).appendChild(input_current_folder);
	}//Fim.
	var title = '';
	data = [];
	if (Element("from_" + border_ID)){
			if (document.getElementById("reply_to_" + border_ID)){
				data.to = document.getElementById("reply_to_values_" + border_ID).value;
				data.to = data.to.replace(/&lt;/gi,"<");
				data.to = data.to.replace(/&gt;/gi,">");
		}
		else {
			if (document.getElementById("from_values_" + border_ID))
			{
				data.to = document.getElementById("from_values_" + border_ID).value;
				data.to = data.to.replace(/&lt;/gi,"<");
				data.to = data.to.replace(/&gt;/gi,">");
			}
		}	
		
		if (document.getElementById("to_values_" + border_ID)){
			data.to_all = document.getElementById("to_values_" + border_ID).value;
			data.to_all = data.to_all.replace(/\n/gi," ");		
			data.to_all = data.to_all.replace(/&lt;/gi,"<");
			data.to_all = data.to_all.replace(/&gt;/gi,">");
			var _array_to_all = data.to_all.split(",");
		}	
	}
	
	if (document.getElementById("cc_" + border_ID)){
		data.cc = document.getElementById("cc_values_" + border_ID).value;
		data.cc = data.cc.replace(/&lt;/gi,"<");
		data.cc = data.cc.replace(/&gt;/gi,">");
	}
	if (document.getElementById("subject_" + border_ID))
		data.subject = document.getElementById("subject_" + border_ID).innerHTML;
	if (document.getElementById("body_" + border_ID))
		data.body = document.getElementById("body_" + border_ID).innerHTML;
	
	if (Element('date_' + border_ID)){
		data.date = Element('date_' + border_ID).innerHTML;
	}
	
	if (Element('date_day_' + border_ID)){
		data.date_day = Element('date_day_' + border_ID).value;
	}
	if (Element('date_hour_' + border_ID)){
		data.date_hour = Element('date_hour_' + border_ID).value;
	}
	var signature = preferences.type_signature == 'html' ? preferences.signature : preferences.signature.replace(/\n/g, "<br>");
	switch(type){
		case "reply_without_history":			
			Element("to_" + new_border_ID).value = data.to;
			title = "Re: " + data.subject;
			Element("subject_" + new_border_ID).value = "Re: " + data.subject;			
			var body = Element("body_" + new_border_ID);
			body.contentWindow.document.open();
			// Insert the signature automaticaly at message body if use_signature preference is set
			if (preferences.use_signature == "1"){ 
				body.contentWindow.document.write("<html><body bgcolor='#FFFFFF'>" + "<br>" + signature + "</body></html>");
			}
			else{ 
			body.contentWindow.document.write("<html><body bgcolor='#FFFFFF'></body></html>");
			}
			body.contentWindow.document.close();
			body.contentWindow.document.designMode = "on";
			//Focus
			if (is_ie)
				window.setTimeout('document.getElementById("body_'+new_border_ID+'").contentWindow.focus();', 300);
			else
				body.contentWindow.focus();
			if (is_ie)
				body.contentWindow.document.onkeypress = function(){if(body.contentWindow.event.keyCode == 13){changeEnterKey(body.contentWindow)}};
			msg_reply_from = document.createElement('input');
			msg_reply_from.id = "msg_reply_from_" + new_border_ID;
			msg_reply_from.type = "hidden";
			msg_reply_from.value = Element("msg_number_" + border_ID).value;
			Element("content_id_" + new_border_ID).appendChild(msg_reply_from);
			break;
		case "reply_with_history":
			title = "Re: " + data.subject;
			Element("subject_" + new_border_ID).value = "Re: " + data.subject;
			Element("to_" + new_border_ID).value = data.to;
			block_quoted_body = make_body_reply(data.body, data.to, data.date_day, data.date_hour);
			var body = Element("body_" + new_border_ID);
			body.contentWindow.document.open();
			// Insert the signature automaticaly at message body if use_signature preference is set
			if (preferences.use_signature == "1") {
				body.contentWindow.document.write("<html><body bgcolor='#FFFFFF'>" + "<br>" + signature + "</body></html>" + block_quoted_body + "</body></html>");
			}
			else {
			body.contentWindow.document.write("<html><body bgcolor='#FFFFFF'>"+block_quoted_body+"</body></html>");
			}
			body.contentWindow.document.close();
			body.contentWindow.document.designMode = "on";
			//Focus
			if (is_ie)
				window.setTimeout('document.getElementById("body_'+new_border_ID+'").contentWindow.focus();', 300);
			else
				body.contentWindow.focus();
			if (is_ie)
				body.contentWindow.document.onkeypress = function(){if(body.contentWindow.event.keyCode == 13){changeEnterKey(body.contentWindow)}};
			msg_reply_from = document.createElement('input');
			msg_reply_from.id = "msg_reply_from_" + new_border_ID;
			msg_reply_from.type = "hidden";
			msg_reply_from.value = Element("msg_number_" + border_ID).value;
			Element("content_id_" + new_border_ID).appendChild(msg_reply_from);
			break;
		case "reply_to_all_without_history":
			// delete user email from to_all array.
			data.to_all = new Array();
			var j = 0;
			for(i = 0; i < _array_to_all.length; i++) {			
				if(_array_to_all[i].lastIndexOf(Element("user_email").value) == "-1"){
					data.to_all[j++] = _array_to_all[i];
				}
			}
			data.to_all = data.to_all.join(",");

			title = "Re: " + data.subject;
			Element("subject_" + new_border_ID).value = "Re: " + data.subject;
			Element("to_" + new_border_ID).value = data.to;
			Element("to_" + new_border_ID).value += ', ' + data.to_all;
			if (data.cc){
				Element("cc_" + new_border_ID).value = data.cc;
				Element("a_cc_link_" + new_border_ID).style.display='none';
				Element("tr_cc_" + new_border_ID).style.display='';
				Element('space_link_' + new_border_ID).style.display='none';
			}
			var body = Element("body_" + new_border_ID);
			body.contentWindow.document.open();
			// Insert the signature automaticaly at message body if use_signature preference is set
			if (preferences.use_signature == "1") {
				body.contentWindow.document.write("<html><body bgcolor='#FFFFFF'>" + "<br>" + signature + "</body></html>");
			}
			else {
			body.contentWindow.document.write("<html><body bgcolor='#FFFFFF'></body></html>");
			}
			body.contentWindow.document.close();
			body.contentWindow.document.designMode = "on";
			//Focus
			if (is_ie)
				window.setTimeout('document.getElementById("body_'+new_border_ID+'").contentWindow.focus();', 300);
			else
				body.contentWindow.focus();
			if (is_ie)
				body.contentWindow.document.onkeypress = function(){if(body.contentWindow.event.keyCode == 13){changeEnterKey(body.contentWindow)}};
			msg_reply_from = document.createElement('input');
			msg_reply_from.id = "msg_reply_from_" + new_border_ID;
			msg_reply_from.type = "hidden";
			msg_reply_from.value = Element("msg_number_" + border_ID).value;
			Element("content_id_" + new_border_ID).appendChild(msg_reply_from);
			break;
		case "reply_to_all_with_history":
			// delete user email from to_all array.
			data.to_all = new Array();
			var j = 0;
				for(i = 0; i < _array_to_all.length; i++) {			
				if(_array_to_all[i].lastIndexOf(Element("user_email").value) == "-1"){
					data.to_all[j++] = _array_to_all[i];
				}
			}
			data.to_all = data.to_all.join(",");
			title = "Re: " + data.subject;
			Element("to_" + new_border_ID).value = data.to;
			Element("to_" + new_border_ID).value += ', ' + data.to_all;
			if (data.cc){
				document.getElementById("cc_" + new_border_ID).value = data.cc;
				document.getElementById("a_cc_link_" + new_border_ID).style.display='none';
				document.getElementById("tr_cc_" + new_border_ID).style.display='';
				document.getElementById('space_link_' + new_border_ID).style.display='none';
			}
			document.getElementById("subject_" + new_border_ID).value = "Re: " + data.subject;
			block_quoted_body = make_body_reply(data.body, data.to, data.date_day, data.date_hour);
			var body = document.getElementById("body_" + new_border_ID);
			body.contentWindow.document.open();
			// Insert the signature automaticaly at message body if use_signature preference is set
			if (preferences.use_signature == "1") {
				body.contentWindow.document.write("<html><body bgcolor='#FFFFFF'>" + "<br>" + signature + "</body></html>" + block_quoted_body + "</body></html>");
			}
			else {
			body.contentWindow.document.write("<html><body bgcolor='#FFFFFF'>"+block_quoted_body+"</body></html>");
			}
			body.contentWindow.document.close();
			body.contentWindow.document.designMode = "on";
			//Focus
			if (is_ie)
				window.setTimeout('document.getElementById("body_'+new_border_ID+'").contentWindow.focus();', 300);
			else
				body.contentWindow.focus();
			if (is_ie)
				body.contentWindow.document.onkeypress = function(){if(body.contentWindow.event.keyCode == 13){changeEnterKey(body.contentWindow)}};
			msg_reply_from = document.createElement('input');
			msg_reply_from.id = "msg_reply_from_" + new_border_ID;
			msg_reply_from.type = "hidden";
			msg_reply_from.value = Element("msg_number_" + border_ID).value;
			Element("content_id_" + new_border_ID).appendChild(msg_reply_from);
			break;
		case "forward":
			data.is_local_message = (document.getElementById("is_local_"+border_ID).value=="1")?true:false;
			msg_forward_from = document.createElement('input');
			msg_forward_from.id = "msg_forward_from_" + new_border_ID;
			msg_forward_from.type = "hidden";
			msg_forward_from.value = Element("msg_number_" + border_ID).value;
			Element("content_id_" + new_border_ID).appendChild(msg_forward_from);			
			title = "Fw: " + data.subject;
			document.getElementById("subject_" + new_border_ID).value = "Fw: " + data.subject;
			var divFiles = Element("divFiles_"+new_border_ID);
			var campo_arquivo
			if (Element("attachments_" + border_ID)){
				var attachments = document.getElementById("attachments_" + border_ID).childNodes;
				for (var i = (attachments.length > 1 ? 1 : 0); i < attachments.length; i++){
					if((attachments[i].tagName=="SPAN") || (attachments[i].tagName=="IMG") ||
							((attachments[i].href.indexOf("javascript:download_local_attachment")==-1)&&(attachments[i].href.indexOf("javascript:download_attachments")==-1)))
						continue; 
					var link_attachment = document.createElement("A");
					link_attachment.setAttribute("href", attachments[i].href);
					link_attachment.innerHTML = attachments[i].innerHTML;
					if (data.is_local_message) {//Local messages
						document.getElementById("is_local_forward"+new_border_ID).value = "1";
						var tmp = link_attachment.href.substring(link_attachment.href.indexOf("(") + 2);//Pula o parenteses e a aspas
						tmp = tmp.substring(0, tmp.length - 2);//corta a aspas e o parenteses
						tmp = replaceAll(tmp,"%20"," ");
						var tempNomeArquivo = tmp.split("/");
						var nomeArquivo = tempNomeArquivo[tempNomeArquivo.length-1];
						nomeArquivo = nomeArquivo.substring(0,nomeArquivo.length - 4); //Anexos no gears so todos com extenso .php. tenho que tirar a extenso para ficar o nome real do arquivo.
						campo_arquivo = addForwardedFile(new_border_ID,nomeArquivo,link_attachment.href);
						
						expresso_local_messages.getInputFileFromAnexo(campo_arquivo, tmp);
					}
					else {
						var tmp = link_attachment.href.replace("javascript:download_attachments(", "").replace(")", "");
						var a_tmp = tmp.split(',');
						tmp = link_attachment.innerHTML.substring(0,link_attachment.innerHTML.lastIndexOf("("));
						a_tmp[2] = "'"+tmp.substring(0,tmp.length-1)+"'";
						s_tmp = escape(connector.serialize(a_tmp));			

						divFiles.innerHTML += "<input style='border:0' type='CHECKBOX' name='forwarding_attachments[]' checked value=\""+s_tmp+"\"/>";
						divFiles.innerHTML += "<link style='border:0' name='file_"+i+"' id='inputFile_"+border_ID+i+"'/>";
						divFiles.appendChild(link_attachment);
					}	
				}
			}
			var body = Element("body_" + new_border_ID);
			body.contentWindow.document.open();
			// Insert the signature automaticaly at message body if use_signature preference is set
			if (preferences.use_signature == "1") {
				body.contentWindow.document.write("<html><body bgcolor='#FFFFFF'>" + "<br>" + signature + "</body></html>" + make_forward_body(data.body, data.to, data.date, data.subject, data.to_all, data.cc) + "</body></html>");
			}
			else {
			body.contentWindow.document.write("<html><body bgcolor='#FFFFFF'>"+make_forward_body(data.body, data.to, data.date, data.subject, data.to_all, data.cc)+"</body></html>");
			}
			body.contentWindow.document.close();
			body.contentWindow.document.designMode = "on";
			if (is_ie)
				body.contentWindow.document.onkeypress = function(){if(body.contentWindow.event.keyCode == 13){changeEnterKey(body.contentWindow)}};
			Element("to_" + new_border_ID).focus();
			break;
		case "new":
			title = get_lang("New Message");
			if(Element('msg_number').value) {
				var _to = Element('msg_number').value;
				var reEmail = /^[A-Za-z\d_-]+(\.[A-Za-z\d_-]+)*@(([A-Za-z\d][A-Za-z\d-]{0,61}[A-Za-z\d]\.)+[A-Za-z]{2,6}|\[\d{1,3}(\.\d{1,3}){3}\])$/;				
				if(!reEmail.test(_to)){
					var array_contacts = contacts.split(',');
					for(i = 0; i < array_contacts.length;i++) {
						if(array_contacts[i].lastIndexOf(_to) != "-1"){
							var _group = array_contacts[i].split(";");
							_to = '"'+_group[0]+'" <'+_group[1]+'>';
							break;
						}
					}
				}
				Element("to_" + new_border_ID).value = _to +',';
				Element('msg_number').value = '';
			}
			var body = document.getElementById("body_" + new_border_ID);
			body.contentWindow.document.open();
			// Insert the signature automaticaly at message body if use_signature preference is set
			if (preferences.use_signature == "1") {
				body.contentWindow.document.write("<html><body bgcolor='#FFFFFF'>" + "<br>" + signature + "</body></html>");
			}
			else {
			body.contentWindow.document.write("<html><body bgcolor='#FFFFFF'></body></html>");
			}
			body.contentWindow.document.close();
			body.contentWindow.document.designMode = "on";
			if (is_ie)
				body.contentWindow.document.onkeypress = function(){if(body.contentWindow.event.keyCode == 13){changeEnterKey(body.contentWindow)}};
			Element("to_" + new_border_ID).focus();			
			break;
		case "edit":
			openTab.imapBox[new_border_ID] = folder_message.value;
			openTab.toPreserve[new_border_ID] = true;
			openTab.imapUid[new_border_ID] = parseInt(border_ID.substr(0,border_ID.indexOf("_")));
			document.getElementById('font_border_id_'+new_border_ID).innerHTML = data.subject;
			data.to = Element("to_values_" + border_ID).value;
			data.to = data.to.replace(/&lt;/gi,"<");
			data.to = data.to.replace(/&gt;/gi,">");
			title = "Edio: "+data.subject;
			
			Element("to_" + new_border_ID).value = data.to;
			if (data.cc){
				Element("cc_" + new_border_ID).value = data.cc;
				Element("space_link_" + new_border_ID).style.display = 'none';
				Element("a_cc_link_" + new_border_ID).style.display = 'none';
				Element("tr_cc_"+ new_border_ID).style.display = '';
			}
			Element("subject_" + new_border_ID).value = data.subject;
			
			var divFiles = Element("divFiles_"+new_border_ID);
			if (Element("attachments_" + border_ID)){
				var attachments = document.getElementById("attachments_" + border_ID).childNodes;
				for (var i = (attachments.length > 1 ? 1 : 0); i < attachments.length; i++){
					var link_attachment = document.createElement("A");
					link_attachment.setAttribute("href", attachments[i].href);
					link_attachment.innerHTML = attachments[i].innerHTML;
					var tmp = link_attachment.href.replace("javascript:download_attachments(", "").replace(")", "");
					var a_tmp = tmp.split(',');
					tmp = link_attachment.innerHTML.substring(0,link_attachment.innerHTML.lastIndexOf("("));
					a_tmp[2] = "'"+tmp.substring(0,tmp.length-1)+"'";
					s_tmp = escape(connector.serialize(a_tmp));
					divFiles.innerHTML += "<input style='border:0' type='CHECKBOX' name='forwarding_attachments[]' checked value=\""+s_tmp+"\"/>";
					divFiles.appendChild(link_attachment);
				}
			}
			var body = Element("body_" + new_border_ID);
			body.contentWindow.document.open();
			body.contentWindow.document.write("<html><body bgcolor='#FFFFFF'>"+data.body+"</body></html>");
			body.contentWindow.document.close();
			body.contentWindow.document.designMode = "on";
			//Focus
			if (is_ie)
				window.setTimeout('document.getElementById("body_'+new_border_ID+'").contentWindow.focus();', 300);
			else
				body.contentWindow.focus();
			if (is_ie)
				body.contentWindow.document.onkeypress = function(){if(body.contentWindow.event.keyCode == 13){changeEnterKey(body.contentWindow)}};
			break;
		default:
	}

	if (preferences.auto_save_draft == 1)
    {
		openTab.autosave_timer[new_border_ID] = false;
		var save_link = document.getElementById("save_message_options"+new_border_ID);

        function auto_sav()
        {
        	if (openTab.autosave_timer[new_border_ID])
			clearTimeout(openTab.autosave_timer[new_border_ID]);

	openTab.autosave_timer[new_border_ID] = setTimeout("save_msg("+new_border_ID+")", autosave_time);
        }
        config_events(body.contentWindow.document,'keypress', auto_sav);
    }

	//BEGIN Tab event
	if (preferences.use_shortcuts == '1')
	{
		if (is_ie)
		{
			body.contentWindow.document.attachEvent('onkeydown', function(event) { if(event.keyCode==27){delete_border(new_border_ID,'false');} if(event.keyCode==9) { Element('to_'+new_border_ID).focus(); Element('send_button_'+new_border_ID).focus(); return false;} }, false);
		}
		else
		{
			body.contentWindow.document.addEventListener('keypress', function(event) { if(event.keyCode==27){delete_border(new_border_ID,'false');} if(event.keyCode==9) { Element('send_button_'+new_border_ID).focus(); event.preventDefault(); } }, false);
		}
	}
	// END Tab event
	
	var offWidth = Element('border_blank').offsetWidth ? Element('border_blank').offsetWidth : Element('border_blank').clientWidth;
	var resize = false;
	
	if (offWidth < 200) {
		resize = Element("border_id_" + new_border_ID).style.width;
	}

	if (title.length > 21){
		title = title.substring(0,21) + "...";
	}
	
	if(resize)
		title = title.substring(0, parseInt(resize)*0.08);

	Element("border_id_" + new_border_ID).innerHTML = "<table width=100% border=0 cellspacing=0 cellpadding=0><tr><td id=font_border_id_" + new_border_ID +" class='font-menu' width=*>" +title + "</td><td width=1px><img onmousedown='javascript:return false' style='cursor:pointer' onclick=delete_border('" + new_border_ID + "','false') src='templates/default/images/close_button.gif'></td></tr></table>";
	return new_border_ID; //Preciso retornar o ID da nova mensagem.
}

// Change the tag <P> for the tag <BR> on IE
function changeEnterKey(win) {
	var oSel = win.document.selection.createRange();
	oSel.pasteHTML("<br />");
	win.event.cancelBubble = true;
	win.event.returnValue=false;
	oSel.select();
	oSel.moveEnd("character",1);
	oSel.moveStart("character",1);
	oSel.collapse(false);
	return false;
}

function send_message_return(data, ID){
	if(data && data.success == true ){
		// if send ok, set a flag as answered or forwarded
		var msg_number_replied = Element('msg_reply_from_'+ID);
		var msg_number_forwarded = Element('msg_forward_from_'+ID);

		if (msg_number_replied){
			set_message_flag(msg_number_replied.value, 'answered');
		}
		else if (msg_number_forwarded){
			set_message_flag(msg_number_forwarded.value, 'forwarded');
		}
		if(wfolders.alert){
			write_msg(get_lang('Your message was sent and save.'));
			wfolders.alert = false;
		}else{
			write_msg(get_lang('Your message was sent.'));
		}
		// If new dynamic contacts were added, update the autocomplete ....
		if(data.new_contacts){
			var ar_contacts = data.new_contacts.split(',;');
			for(var j in ar_contacts){
				// If the dynamic contact don't exist, update the autocomplete....
				if((contacts+",").indexOf(";"+ar_contacts[j]+",") == -1)
					contacts += ",;" + ar_contacts[j];
			}
		}
		if ((! openTab.toPreserve[ID]) && (openTab.imapUid[ID] != 0))
			cExecute ("$this.imap_functions.delete_msgs&folder="+openTab.imapBox[ID]+"&msgs_number="+openTab.imapUid[ID],function(data){ return });
		delete_border(ID,'true'); // Becarefull: email saved automatically should be deleted. delete_border erase information about openTab
 	}
	else{
		if(data == 'Post-Content-Length')
			write_msg(get_lang('The size of this message has exceeded  the limit (%1B).',Element('upload_max_filesize').value));
		else if(data)
			write_msg(data);
		else
			write_msg(get_lang("Connection failed with %1 Server. Try later.", "Web"));
	}
}

function send_message(ID, folder, folder_name){
	var save_link = Element("save_message_options_"+ID);
	save_link.onclick = '';
	save_link.style.color = '#999';
	
	ID_tmp = ID;

	var handler_send_message = function(data){
		send_message_return(data, this.ID_tmp); // this is a hack to escape quotation form connector bug
	};
		
	var textArea = document.createElement("TEXTAREA");
	textArea.style.display='none';
	textArea.name = "body";
	body = document.getElementById("body_"+ID);
	textArea.value += '<body>\r\n';
	textArea.value += body.contentWindow.document.body.innerHTML;
	textArea.value += '\r\n</body>';
	var input_folder = document.createElement("INPUT");
	input_folder.style.display='none';
	input_folder.name = "folder";
	input_folder.value = folder;
	var msg_id = document.createElement("INPUT");
	msg_id.style.display='none';
	msg_id.name = "msg_id";
	msg_id.value = openTab.imapUid[ID];
	
	if (is_ie){
		var i = 0;
		while (document.forms(i).name != "form_message_"+ID){i++}
		form = document.forms(i);
	}
	else
		form = document.forms["form_message_"+ID];
	
	form.appendChild(textArea);
	form.appendChild(input_folder);
	form.appendChild(msg_id);

	var _subject = trim(Element("subject_"+ID).value);
	if((_subject.length == 0) && !confirm(get_lang("Send this message without a subject?"))) {
		Element("subject_"+ID).focus();
		return;
	}
	
	cExecuteForm ("$this.imap_functions.send_mail", form, handler_send_message, ID);
}

function return_save(data,border_id,folder_name,folder_id,message_id)
{
	var handler_delete_msg = function(data){ refresh(preferences.alert_new_msg); };

	if (data.append != true || !data)
	{
		RichTextEditor.saveFlag = -1;
		if (! data.append)
			write_msg('ERROR saving your message.');
		else
		{
			if (data.append.match(/^(.*)TRYCREATE(.*)$/))
			{
				connector.loadScript('TreeS');
				alert(get_lang('There is not %1 folder, Expresso is creating it for you... Please, repeat your request later.',draftsfolder));
				connector.loadScript('TreeShow');
				ttree.FOLDER = 'root';
				ttreeBox.new_past(draftsfolder);
				setTimeout('save_msg('+border_id+')',3000);
			}
			else
				write_msg(data.append);
		}
	}
	else
	{
		RichTextEditor.saveFlag = 1;
		openTab.imapUid[border_id] = data.msg_no;
		openTab.imapBox[border_id] = data.folder_id;
		
		var newTitle = document.getElementById('subject_'+border_id).value;
		if (newTitle.length > 18)
			newTitle = newTitle.substr(18) + '...';
		else if (newTitle == '')
				newTitle = get_lang("No subject");
		document.getElementById('font_border_id_'+border_id).innerHTML = newTitle;
		
		// Replace the embedded images for new uids
		var mainField = document.getElementById('body_'+border_id).contentWindow;
		var content_body =  mainField.document.getElementsByTagName('body').item(0).innerHTML;
		var body_images = content_body.match(/msg_num=\d*/g);
		var images_part = content_body.match(/msg_part=\d*/g);
		if (body_images)
		{
			for (var i=0; i<body_images.length; i++){
				content_body = 	content_body.replace(body_images[i],"msg_num="+openTab.imapUid[border_id]);
			}
			var allImgs = new Array (images_part.length);
				var j=-1;
				for (var i in images_part){
				
					if (is_ie)
						if (i == 0)
							var image_number = parseInt(images_part[i].substr(9));
						else
							image_number = "null";
					else
						var image_number = parseInt(images_part[i].substr(9));
					
				if (! isNaN(image_number))
					{
						if (! allImgs[image_number])
						{
							allImgs[image_number] = true;
							j--;					
						}
					content_body = content_body.replace(images_part[i],'msg_part='+j);
					}
				}
			content_body = content_body.replace(/msg_part=-/g,'msg_part=');
			
			mainField.document.getElementsByTagName('body').item(0).innerHTML = content_body;
		}	
				
		//Replace all files to new files
		var divFiles = Element("divFiles_"+border_id);
		var divParent = divFiles.parentNode;
		divParent.removeChild(divFiles);
		divFiles = document.createElement('DIV');
		divFiles.id = "divFiles_"+border_id;
		divParent.appendChild(divFiles);
		
		var attach_files = connector.unserialize(data.files);
		if (attach_files != null) {
			openTab.countFile[border_id] = attach_files.length;
		for (att_index = 0; att_index < attach_files.length; att_index++){
	
			var link_attachment = document.createElement("A");
			var fileName = attach_files[att_index].substr(0,attach_files[att_index].indexOf('_SIZE_'));
			var fileSize = parseInt(attach_files[att_index].substr(attach_files[att_index].indexOf('_SIZE_')+6))/1024
			link_attachment.innerHTML = fileName + " ("+parseInt(fileSize)+" kb)";

			var href = "'"+folder_id+"','"+data.msg_no+"','"+(att_index)+"','"+(att_index+2)+"','base64'";

			link_attachment.setAttribute("href", "javascript:download_attachments("+href+")");

			var a_tmp = href.split(',');
			a_tmp[2] = fileName;
			s_tmp = escape(connector.serialize(a_tmp));
					
			var check_attachment = document.createElement("INPUT");
			check_attachment.type = 'CHECKBOX';
			check_attachment.name = 'forwarding_attachments[]';
			check_attachment.value = s_tmp;

			divFiles.appendChild(check_attachment);
			divFiles.appendChild(link_attachment);
			divFiles.appendChild(document.createElement("BR"));

			check_attachment.checked = true;
		}
	}
		if (message_id)
		{
			cExecute ("$this.imap_functions.delete_msgs&folder="+openTab.imapBox[border_id]+"&msgs_number="+message_id,handler_delete_msg);
			if (openTab.imapBox[0] == "INBOX/"+draftsfolder)
			{
				//Update mailbox
                                var tr_msg = document.getElementById(message_id);
				change_tr_properties(tr_msg, data.msg_no, data.subject);
			}
		
		}
		var save_link = Element("save_message_options_"+border_id);
		save_link.onclick = '';
		save_link.style.color = '#999';
		watch_changes_in_msg(border_id);
		Element("send_button_"+border_id).style.visibility="visible";
		write_msg(get_lang('Your message was save as draft in folder %1.', lang_folder(folder_name)));
	}		
}

function save_msg(border_id){
	var sendButton = Element("send_button_"+border_id);
	if (sendButton)
		sendButton.style.visibility="hidden";

	if (openTab.imapBox[border_id]) //Gets the imap folder
		var folder_id = openTab.imapBox[border_id];
	else
		var	folder_id = "INBOX/"+draftsfolder;

	if (folder_id == 'INBOX') // and folder name from border
		var folder_name = get_lang(folder_id);
	else
		var folder_name = folder_id.substr(6);
		
	// hack to avoid form connector bug,  escapes quotation. Please see #179
	tmp_border_id=border_id;
	tmp_folder_name=folder_name;
	tmp_folder_id=folder_id;
	message_id = openTab.imapUid[border_id];
	var handler_save_msg = function(data){ return_save(data,this.tmp_border_id,this.tmp_folder_name,this.tmp_folder_id,this.message_id); }

	var textArea = document.createElement("TEXTAREA");
	textArea.style.display='none';
	textArea.name = "body";
	body = document.getElementById("body_"+border_id);
	if (! body)
		return;
	textArea.value += '<body>\r\n';
	textArea.value += body.contentWindow.document.body.innerHTML;
	textArea.value += '\r\n</body>';
	var input_folder = document.createElement("INPUT");
	input_folder.style.display='none';
	input_folder.name = "folder";
	input_folder.value = folder_id;
	var input_msgid = document.createElement("INPUT");
	input_msgid.style.display='none';
	input_msgid.name = "msg_id";
	input_msgid.value = message_id;
	
	if (is_ie){
		var i = 0;
		while (document.forms(i).name != "form_message_"+border_id){i++}
		form = document.forms(i);
	}
	else
		form = document.forms["form_message_"+border_id];
	form.appendChild(textArea);
	form.appendChild(input_folder);
	form.appendChild(input_msgid);

	cExecuteForm ("$this.imap_functions.save_msg", form, handler_save_msg,border_id);	
}

function return_saveas(data,border_id,folder_name)
{
	if(!verify_session(data))
		return;
	if (data.append)
	{
		delete_border(border_id,null);
		write_msg(get_lang('Your message was save as draft in folder %1.', folder_name));
	}
	else
		write_msg('ERROR saving your message.');					
}


function save_as_msg(border_id, folder_id, folder_name){
	// hack to avoid form connector bug,  escapes quotation. Please see #179
	tmp_border_id=border_id;
	tmp_folder_name=folder_name;
	var handler_save_msg = function(data){ return_saveas(data,this.tmp_border_id,this.tmp_folder_name); }	
	var textArea = document.createElement("TEXTAREA");
	textArea.style.display='none';
	textArea.name = "body";
	body = document.getElementById("body_"+border_id);
	textArea.value += '<body>\r\n';
	textArea.value += body.contentWindow.document.body.innerHTML;
	textArea.value += '\r\n</body>';
	
	var input_folder = document.createElement("INPUT");
	input_folder.style.display='none';
	input_folder.name = "folder";
	input_folder.value = folder_id;
	
	if (is_ie){
		var i = 0;
		while (document.forms(i).name != "form_message_"+border_id){i++}
		form = document.forms(i);
	}
	else
		form = document.forms["form_message_"+border_id];
	form.appendChild(textArea);
	form.appendChild(input_folder);
	
	cExecuteForm ("$this.imap_functions.save_msg", form, handler_save_msg,border_id);
}


// Get checked messages
function set_messages_flag(flag, msgs_to_set){
	var handler_set_messages_flag = function (data){
		
		if(!verify_session(data))
			return;
		var msgs_to_set = data.msgs_to_set.split(",");

		if(!data.status) {
			alert(data.msg);
			Element('chk_box_select_all_messages').checked = false;
			for (var i = 0; i < msgs_to_set.length; i++) {
				Element("check_box_message_" + msgs_to_set[i]).checked = false;
				remove_className(Element(msgs_to_set[i]), 'selected_msg');
			}
			if(!data.msgs_unflageds)
				return;
			else
				msgs_to_set = data.msgs_unflageds.split(",");
		}
		

		for (var i=0; i<msgs_to_set.length; i++){
			if(Element("check_box_message_" + msgs_to_set[i])){
				switch(data.flag){
					case "unseen":
						set_msg_as_unread(msgs_to_set[i]);
						Element("check_box_message_" + msgs_to_set[i]).checked = false;
						break;
					case "seen":
						set_msg_as_read(msgs_to_set[i], false);
						Element("check_box_message_" + msgs_to_set[i]).checked = false;
						break;
					case "flagged":
						set_msg_as_flagged(msgs_to_set[i]);
						document.getElementById("check_box_message_" + msgs_to_set[i]).checked = false;
						break;
					case "unflagged":
						set_msg_as_unflagged(msgs_to_set[i]);
						Element("check_box_message_" + msgs_to_set[i]).checked = false;
						break;
				}
			}
		}
		Element('chk_box_select_all_messages').checked = false;
	}
	
	var folder = get_current_folder();
	if (msgs_to_set == 'get_selected_messages')
		var msgs_to_set = this.get_selected_messages();
	else
		folder = Element("input_folder_"+msgs_to_set+"_r").value;
	
	if (msgs_to_set)
		cExecute ("$this.imap_functions.set_messages_flag&folder="+folder+"&msgs_to_set="+msgs_to_set+"&flag="+flag, handler_set_messages_flag);
	else
		write_msg(get_lang('No selected message.'));		
}

// By message number
function set_message_flag(msg_number, flag){
	var msg_number_folder = Element("new_input_folder_"+msg_number+"_r");
	var handler_set_messages_flag = function (data){
		if(!verify_session(data))
			return;
		if (data.status && Element("td_message_answered_"+msg_number)) {	
			if(flag == 'answered')
				Element("td_message_answered_"+msg_number).innerHTML = '<img src=templates/default/images/answered.gif title=Respondida>';
			else if(flag == 'forwarded')
				Element("td_message_answered_"+msg_number).innerHTML = '<img src=templates/default/images/forwarded.gif title=Encaminhada>';
		}
	}
	cExecute ("$this.imap_functions.set_messages_flag&folder="+( msg_number_folder ?  msg_number_folder.value : get_current_folder() )+"&msgs_to_set="+msg_number+"&flag="+flag, handler_set_messages_flag);
}

function print_all(){
	var folder= Element('border_id_0').innerHTML;
	var body = Element('divScrollMain_'+numBox).innerHTML;
	var print_width = screen.width - 200;
	var x = ((screen.width - print_width) / 2);
	var y = ((screen.height - 400) / 2) - 35;
	var window_print = window.open('','ExpressoMail','width='+print_width+',height=400,resizable=yes,scrollbars=yes,left='+x+',top='+y);
	var seekDot = /\<img /gi;
	body = body.replace(seekDot, "<img style='display:none' ");
	seekDot = /\<input /gi;
	body = body.replace(seekDot, "<input style='display:none' ");
	
	while (1){
		try{
			var html = '<br>';
			html += "<h4>ExpressoLivre - ExpressoMail</h4>";
			html += folder+"<hr>";
			
			window_print.document.body.innerHTML = html + '<blockquote><font size="2">' +
			'<table style="font-size:12" width="'+(is_ie ? "85%" : "99%" )+'"><TR><TD align="center" width="5%">&nbsp;</TD><TD width="30%" align="center">'+get_lang("Who")+'</TD><TD align="center" width="45%">'+get_lang("Subject")+'</TD><TD align="center" width="10%">'+get_lang("Date")+'</TD><TD width="10%">'+get_lang("Size")+'</TD></TR></table>'
			+ body + '</font></blockquote>';
			break;
		}
		catch(e){
			//alert(e.message);
		}
	}
	window_print.document.close();
	window_print.print();
}


function print_msg(msg_folder, msg_number, border_ID){
	var div_toaddress_full = Element("div_toaddress_full_"+border_ID);	
	var div_ccaddress_full = Element("div_ccaddress_full_"+border_ID);
	var printListTO = (div_toaddress_full && div_toaddress_full.style.display != 'none') || toaddress_array[border_ID].length == 1 ? true : false;	
	var printListCC = (div_ccaddress_full && div_ccaddress_full.style.display != 'none') || !div_ccaddress_full ? true : false;	
	var sender		= Element('sender_values_'+border_ID) ? Element('sender_values_'+border_ID).value : null;
	var from		= Element('from_values_'+border_ID) ? Element('from_values_'+border_ID).value : null;
	var to			= Element('to_values_'+border_ID) ? Element('to_values_'+border_ID).value :null;
	var cc 			= Element('cc_values_'+border_ID) ? Element('cc_values_'+border_ID).value : null;		
	var date		=  Element('date_'+border_ID);	
	var subject		= Element('subject_'+border_ID);
	var attachments	= Element('attachments_'+border_ID);
	var body		= Element('body_'+border_ID);

	var print_width = screen.width - 200;
	var x = ((screen.width - print_width) / 2);
	var y = ((screen.height - 400) / 2) - 35;
	var window_print = window.open('','ExpressoMail','width='+print_width+',height=400,resizable=yes,scrollbars=yes,left='+x+',top='+y);
	if(window_print == null) {
		alert(get_lang("The Anti Pop-Up is enabled. Allow this site (%1) for print.",document.location.hostname));
		return;
	}
	
	while (1){
		try{
			var html = '<br><br>';
			//html += "<input type='button' value='Imprimir' onclick='javascript:window.print();'>";
			html += "<h4>ExpressoLivre - ExpressoMail</h4><hr>";
			html += '<table><tbody>';
			if(sender)
				html += "<tr><td width=7% noWrap><font size='2'>" + get_lang('Sent by') + ": </font></td><td><font size='2'>"+sender+"</font></td></tr>";
			if(from)
				html += "<tr><td width=7%><font size='2'>" + get_lang('From') + ": </font></td><td><font size='2'>"+from+"</font></td></tr>";
			if(to) {
				if(!printListTO)
					to = 'Os destinatrios no esto sendo exibidos para esta impresso';
				html += "<tr><td width=7%><font size='2'>" + get_lang('To') + ": </font></td><td><font size='2'>"+to+"</font></td></tr>";
			}			
			if (cc) {
				if(!printListCC)
					cc = 'Os destinatrios no esto sendo exibidos para esta impresso';
				html += "<tr><td width=7%><font size='2'>" + get_lang('Cc') + ": </font></td><td><font size='2'>"+cc+"</font></td></tr>";
			}
			if(date)
				html += "<tr><td width=7%><font size='2'>" + get_lang('Date') + ": </font></td><td><font size='2'>"+date.innerHTML+"</font></td></tr>";			
			html += "<tr><td width=7%><font size='2'>" + get_lang('Subject')+ ": </font></td><td><font size='2'>"+subject.innerHTML+"</font></td></tr>";
			html += "</tbody></table><hr>";
			window_print.document.body.innerHTML = html + '<blockquote><font size="2">' + body.innerHTML + '</font></blockquote>';
			if(!is_ie){
				var tab_tags = window_print.document.getElementsByTagName("IMG");			
				for(var i = 0; i < tab_tags.length;i++){
					var _img = document.createElement("IMG");
					_img.src = tab_tags[i].src;
					tab_tags[i].parentNode.replaceChild(_img,tab_tags[i]);
				}
			}
			break;
		}
		catch(e){
			//alert(e.message);
		}
	}
	window_print.document.close();
	window_print.print();
}

function empty_trash_imap(){
	var handler_empty_trash = function(data){
		Element('chk_box_select_all_messages').checked = false;
		if(!verify_session(data))
			return;
		if (get_current_folder() == 'INBOX'+cyrus_delimiter+trashfolder){
			draw_paging(0);
			kill_current_box();
		}
		tree_folders.getNodeById('INBOX'+cyrus_delimiter+trashfolder).alter({caption: get_lang("Trash")});
		tree_folders.getNodeById('INBOX'+cyrus_delimiter+trashfolder)._refresh();
		update_quota(get_current_folder());
		if (data)
			write_msg(get_lang('Your Trash folder was empty.'));
		else
			write_msg(get_lang('ERROR emptying your Trash folder.'));
	}
	var realyEmptyTrash=confirm(get_lang('Do you really want to empty your trash folder?'));
	if (realyEmptyTrash)
		cExecute ("$this.imap_functions.empty_trash", handler_empty_trash);
}

function export_all_selected_msgs(){
	
	var msgs_to_export = this.get_selected_messages();
	
	var handler_export_all_selected_msgs = function(data){
	
		if(!data){
			write_msg(get_lang('Error compressing messages (ZIP). Contact the administrator.'));
		}
		else
			download_attachments(null, null, data, null,null,'mensagens.zip');
	}
	
	if (msgs_to_export) {
		cExecute ("$this.exporteml.makeAll", handler_export_all_selected_msgs, "folder="+get_current_folder()+"&msgs_to_export="+msgs_to_export);
		write_msg(get_lang('You must wait while the messages will be exported...'));
	}
	else
		write_msg(get_lang('No selected message.'));
}

function select_all_search_messages(select, id){
	var search_box = Element("table_resultsearch_" + id.substr(18)).firstChild;
	var felement = search_box.firstChild;
	while(felement)
	{
	if (select)
		felement.firstChild.firstChild.checked = true;
	else
		felement.firstChild.firstChild.checked = false;
	felement = felement.nextSibling;
	}
}

function verify_session(data){

	if(data && data.imap_error) {
		if(data.imap_error == "nosession")
			write_msg(get_lang("your session could not be verified."));
		else
			write_msg(data.imap_error);
		// Hold sesion for edit message.
		//if(!hold_session)
		//	location.href="../login.php?cd=10&phpgw_forward=%2FexpressoMail1_2%2Findex.php";		
		return false;
	}
	else
		return true;
}

// Save image file.
function save_image(e,thumb){
	thumb.oncontextmenu = function(e) {
		return false;
	}
	var _button = is_ie ? window.event.button : e.which;
	var	_target = is_ie ? event.srcElement : e.target;
	
	if(_button == 2 || _button == 3) {
		var _params = _target.id.split(";;");
		download_attachments(_params[0],_params[1],_params[2],_params[3],_params[4]);
	}
}

function nospam(msgs_number, border_ID, folder){
	if (folder == 'null')
		folder = get_current_folder();
	var new_folder 	= 'INBOX';
	var new_folder_name = get_lang('INBOX');
	var handler_move_msgs = function(data){
		if (msgs_number == 'selected')	
			set_messages_flag("unseen", "get_selected_messages");
		else
			set_message_flag(msgs_number, "unseen");
   	    proxy_mensagens.proxy_move_messages(folder, msgs_number, border_ID, new_folder, new_folder_name);
	}

    if (msgs_number == 'selected')
	   	msgs_number = get_selected_messages();
       
	if (parseInt(msgs_number) > 0 || msgs_number.length > 0)
		cExecute ("$this.imap_functions.spam&folder="+folder+"&spam=false"+"&msgs_number="+msgs_number+"&border_ID="+border_ID+"&sort_box_type="+sort_box_type+"&sort_box_reverse="+sort_box_reverse+"&reuse_border="+border_ID+"&new_folder="+new_folder+"&new_folder_name="+new_folder_name+"&get_previous_msg="+preferences.delete_and_show_previous_message+"&cyrus_delimiter="+cyrus_delimiter, handler_move_msgs);
	else
		write_msg(get_lang('No selected message.'));
}

function spam(folder, msgs_number, border_ID){
	if (folder == 'null')
		folder = get_current_folder();
    var new_folder 		= 'INBOX'+cyrus_delimiter+'Spam';
	var new_folder_name = 'Spam';
	var handler_move_msgs = function(data){
		// debug
		// alert(data);
		proxy_mensagens.proxy_move_messages(folder, msgs_number, border_ID, new_folder, new_folder_name);
	}
    if(msgs_number == 'selected')
		msgs_number = get_selected_messages();
	if(parseInt(msgs_number) > 0 || msgs_number.length > 0)
		cExecute ("$this.imap_functions.spam&folder="+folder+"&spam=true"+"&msgs_number="+msgs_number+"&border_ID="+border_ID+"&sort_box_type="+sort_box_type+"&sort_box_reverse="+sort_box_reverse+"&reuse_border="+border_ID+"&new_folder="+new_folder+"&new_folder_name="+new_folder_name+"&get_previous_msg="+preferences.delete_and_show_previous_message+"&cyrus_delimiter="+cyrus_delimiter, handler_move_msgs);
	else
    	write_msg(get_lang('No selected message.'));
}

function import_window(){
	var win = arrayJSWin["import_window"];
	var form_upload = Element("form_upload");
	if(!win) {
		var form = document.createElement("DIV");
		form.id  = "import_window";
		form.style.visibility = "hidden";
		form.style.position = "absolute";
		form.style.background = "#eeeeee";
		form.style.left = "0px";
		form.style.top  = "0px"; 
		form.style.width = "0px";
		form.style.height = "0px";
		document.body.appendChild(form);
		form_upload = document.createElement("DIV");
		form_upload.id = "form_upload";
		form_upload.style.position = "absolute";
		form_upload.style.top = "5px";
		form_upload.style.left = "5px";
		form_upload.name =  get_lang('zip mails to import');
		form_upload.style.width = "450px";
		form_upload.style.height = "75px";
		form.appendChild(form_upload);	
		form.style.width  =  form.firstChild.style.width;
		form.style.height = form.firstChild.style.height;
		form.style.zIndex = "10000";			
		var title = form.firstChild.name;
		var wHeight = form.offsetHeight + "px";
		var wWidth =  form.offsetWidth   + "px";
		form.style.width = form.offsetWidth - 5;
		win = new dJSWin({
			id: 'win_'+form.id,
			content_id: form.id,
			width: wWidth,
			height: wHeight,
			title_color: '#3978d6',
			bg_color: '#eee',
			title: title,
			title_text_color: 'white',
			button_x_img: '../phpgwapi/images/winclose.gif',
			border: true });	
		win.draw();
	}
	form_upload.innerHTML = '<form method="POST" name="form_import" enctype="multipart/form-data">'+get_lang('zip mails to import')+':<br>'+
	'<input name="file_1" maxlength="255" size="50" id="file_1" type="file"><br>' +
	'<input title="'+get_lang('Select a folder')+'"  value="' + get_lang('Select a folder') + '"' + 'type="button" onclick="javascript:select_import_folder()">&nbsp;' +
	'<input title="' + get_lang('Close') + '"  value="' + get_lang('Close') + '"' +
	' type="button" onclick="arrayJSWin[\'import_window\'].close()"></form>';	
	win.open();
}

function import_msgs(wfolders_tree){
	function handler(data){		
		// Its necessary to encapsulate the data returned (IE bugfix)
		return_import_msgs(data,wfolders_tree);		
	}
	var countFiles = document.form_import.countFiles;
	if(!countFiles){
		countFiles = document.createElement("INPUT");
		countFiles.type = "hidden";
		countFiles.name = "countFiles";
		countFiles.value = "1";
		document.form_import.appendChild(countFiles);
	}
	var folder = document.createElement("INPUT");
	folder.type = "hidden";
	folder.name = "folder";
	folder.value = wfolders_tree._selected.id;
	document.form_import.appendChild(folder);
	write_msg(get_lang('You must wait while the messages will be imported...'));
	
	cExecuteForm('$this.imap_functions.import_msgs', document.form_import, handler);
}
function return_import_msgs(data, wfolders_tree){
	if(data && data.error){
		write_msg(data.error);
	}
	else{
		if(data == 'Post-Content-Length')
			write_msg(get_lang('The size of this message has exceeded  the limit (%1B).',Element('upload_max_filesize').value));
		else {
			write_msg(data);
			arrayJSWin["import_window"].close();
			if(openTab.imapBox[0] == wfolders_tree._selected.id){
				openTab.imapBox[0] = '';
				change_folder(wfolders_tree._selected.id, wfolders_tree._selected.caption);
			}
			else{
				refresh();
			}
		}
	}
}

function select_import_folder(){
	//Begin: Verify if the file extension is allowed.
	var imgExtensions = new Array("eml","zip");
	var inputFile = document.form_import.file_1;	
	if(!inputFile.value){
		alert(get_lang('File extension forbidden or invalid file') + '.');
		return false;
	}
	var fileExtension = inputFile.value.split(".");
	fileExtension = fileExtension[(fileExtension.length-1)];
	var deniedExtension = true;
	for(var i=0; i<imgExtensions.length; i++) {
		if(imgExtensions[i].toUpperCase() == fileExtension.toUpperCase()) {
			deniedExtension = false;
			break;
		}
	}
	if(deniedExtension) {
		alert(get_lang('File extension forbidden or invalid file') + '.');
		return false;
	}
	arrayJSWin['import_window'].close();
	wfolders.makeWindow('null','import');
}
function import_calendar(data){
	function handler_import_calendar(data){
		if(data === true){
			write_msg(get_lang("The event was imported successfully."));
		}
	}
	if(confirm(get_lang("Do you confirm this import to your Calendar?"))){
			cExecute('$this.db_functions.import_vcard&msg_folder='+data,handler_import_calendar);
	}
}
